"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
exports.Subscription = void 0;
const pulumi = require("@pulumi/pulumi");
const utilities = require("./utilities");
/**
 * The `postgresql.Subscription` resource creates and manages a publication on a PostgreSQL
 * server.
 *
 * ## Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as postgresql from "@pulumi/postgresql";
 *
 * const subscription = new postgresql.Subscription("subscription", {
 *     name: "subscription",
 *     conninfo: "host=localhost port=5432 dbname=mydb user=postgres password=postgres",
 *     publications: ["publication"],
 * });
 * ```
 *
 * ## Postgres documentation
 *
 * - https://www.postgresql.org/docs/current/sql-createsubscription.html
 */
class Subscription extends pulumi.CustomResource {
    /**
     * Get an existing Subscription resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param state Any extra arguments used during the lookup.
     * @param opts Optional settings to control the behavior of the CustomResource.
     */
    static get(name, id, state, opts) {
        return new Subscription(name, state, Object.assign(Object.assign({}, opts), { id: id }));
    }
    /**
     * Returns true if the given object is an instance of Subscription.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    static isInstance(obj) {
        if (obj === undefined || obj === null) {
            return false;
        }
        return obj['__pulumiType'] === Subscription.__pulumiType;
    }
    constructor(name, argsOrState, opts) {
        let resourceInputs = {};
        opts = opts || {};
        if (opts.id) {
            const state = argsOrState;
            resourceInputs["conninfo"] = state ? state.conninfo : undefined;
            resourceInputs["createSlot"] = state ? state.createSlot : undefined;
            resourceInputs["database"] = state ? state.database : undefined;
            resourceInputs["name"] = state ? state.name : undefined;
            resourceInputs["publications"] = state ? state.publications : undefined;
            resourceInputs["slotName"] = state ? state.slotName : undefined;
        }
        else {
            const args = argsOrState;
            if ((!args || args.conninfo === undefined) && !opts.urn) {
                throw new Error("Missing required property 'conninfo'");
            }
            if ((!args || args.publications === undefined) && !opts.urn) {
                throw new Error("Missing required property 'publications'");
            }
            resourceInputs["conninfo"] = (args === null || args === void 0 ? void 0 : args.conninfo) ? pulumi.secret(args.conninfo) : undefined;
            resourceInputs["createSlot"] = args ? args.createSlot : undefined;
            resourceInputs["database"] = args ? args.database : undefined;
            resourceInputs["name"] = args ? args.name : undefined;
            resourceInputs["publications"] = args ? args.publications : undefined;
            resourceInputs["slotName"] = args ? args.slotName : undefined;
        }
        opts = pulumi.mergeOptions(utilities.resourceOptsDefaults(), opts);
        const secretOpts = { additionalSecretOutputs: ["conninfo"] };
        opts = pulumi.mergeOptions(opts, secretOpts);
        super(Subscription.__pulumiType, name, resourceInputs, opts);
    }
}
exports.Subscription = Subscription;
/** @internal */
Subscription.__pulumiType = 'postgresql:index/subscription:Subscription';
//# sourceMappingURL=subscription.js.map